// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#pragma once


class CLightingControlDialogListener
{
public:
	virtual ~CLightingControlDialogListener() {}
	virtual void OnLightingDialogApplyButton() = 0;
};

// CLightingControlDialog dialog

class CLightingControlDialog : public CDialog
{
	DECLARE_DYNAMIC(CLightingControlDialog)

public:
	CLightingControlDialog(CWnd* pParent = NULL, CLightingControlDialogListener * pListener = NULL);   // standard constructor
	virtual ~CLightingControlDialog();

	void UpdateDialogValues() {
		UpdateData(FALSE);
	}

	void UpdateClassValues() {
		UpdateData(TRUE);
	}

// Dialog Data
	enum { IDD = IDD_LIGHTING_CONTROL_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	CLightingControlDialogListener * m_pListener;

	DECLARE_MESSAGE_MAP()
public:
	int m_nLightingMode;
	afx_msg void OnBnClickedLightcontrolApplyButton();
	int m_nShowCoordAxes;
protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
public:
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	int m_nMeshColorMode;
	COLORREF m_bgColor;
	COLORREF m_meshColor;
	int m_nShadingMode;
	float m_fAmbientValue;
	afx_msg void OnBnClickedLcBackgroundcolor();
	afx_msg void OnBnClickedLcMeshcolor();
	afx_msg void OnBnClickedLcAmbientvalue();
};
