// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


// SetFloatValueDialog.cpp : implementation file
//

#include "stdafx.h"
#include "BlobShop.h"
#include "SetFloatValueDialog.h"
#include ".\setfloatvaluedialog.h"


// CSetFloatValueDialog dialog

IMPLEMENT_DYNAMIC(CSetFloatValueDialog, CDialog)
CSetFloatValueDialog::CSetFloatValueDialog(float fMinValue, 
										   float fMaxValue, 
										   float fCurrent,
										   const char * pName,
										   bool bInteger,
										   CWnd* pParent)
	: CDialog(CSetFloatValueDialog::IDD, pParent)
{
	m_fMinValue = fMinValue;
	m_fMaxValue = fMaxValue;
	m_fCurrentValue = fCurrent;
	m_pName = pName;
	m_bInteger = bInteger;
}

CSetFloatValueDialog::~CSetFloatValueDialog()
{
}

void CSetFloatValueDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CSetFloatValueDialog, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// CSetFloatValueDialog message handlers

void CSetFloatValueDialog::OnBnClickedOk()
{
	// get value
	CString str;
	GetDlgItem(IDC_ValueEdit)->GetWindowText(str);

	// convert to float
	if ( !m_bInteger ) {
		char * pStop;
		float fValue = (float)strtod((const char *)str, &pStop );
		if ( fValue < m_fMinValue || fValue > m_fMaxValue ) {
			char buf[256];
			_snprintf(buf, 255, "Value %.5f is out of range", fValue);
			buf[255] = '\0';
			MessageBox(buf, "Invalid Value", MB_OK);
			return;
		} else {
			m_fNewValueFloat = fValue;
		}
	} else {
		char * pStop;
		int nValue = strtol((const char *)str, &pStop, 10 );
		if ( (float)nValue < m_fMinValue || (float)nValue > m_fMaxValue ) {
			char buf[256];
			_snprintf(buf, 255, "Value %d is out of range", nValue);
			buf[255] = '\0';
			MessageBox(buf, "Invalid Value", MB_OK);
			return;
		} else {
			m_fNewValueInt = nValue;
		}
	}

	// TODO: Add your control notification handler code here
	OnOK();
}

BOOL CSetFloatValueDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	char buf[256];
	_snprintf(buf, 255, "Set %s", m_pName);
	buf[255] = '\0';
	SetWindowText(buf);

	_snprintf(buf, 255, "%s:", m_pName);
	buf[255] = '\0';
	GetDlgItem(IDC_ValueLabel)->SetWindowText(buf);
	
	if ( m_bInteger )
		_snprintf(buf, 255, "%d to %d", (int)m_fMinValue, (int)m_fMaxValue );
	else
		_snprintf(buf, 255, "%.3f to %.3f", m_fMinValue, m_fMaxValue );
	buf[255] = '\0';
	GetDlgItem(IDC_RangeLabel)->SetWindowText(buf);

	if ( m_bInteger ) {
		_snprintf(buf, 255, "%d", (int)m_fCurrentValue );
	} else {
		_snprintf(buf, 255, "%.5f", m_fCurrentValue );
	}
	buf[255] = '\0';
	GetDlgItem(IDC_ValueEdit)->SetWindowText(buf);

	// set focus to value edit
	GetDlgItem(IDC_ValueEdit)->SetFocus();
	((CEdit *)GetDlgItem(IDC_ValueEdit))->SetSel(0,-1);

	return FALSE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
