// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


// SketchFramework.h : main header file for the SketchFramework application
//
#pragma once

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols


// CSketchFrameworkApp:
// See SketchFramework.cpp for the implementation of this class
//

class CSketchFrameworkApp : public CWinApp
{
public:
	enum MDIWindowType { FieldImageWindow, BlobTreeEditorWindow, RayTracedWindow };

	CSketchFrameworkApp();

	CMDIChildWnd * CreateNewMDIWindow(MDIWindowType eType);

// Overrides
public:
	virtual BOOL InitInstance();

// Implementation
	afx_msg void OnAppAbout();
	DECLARE_MESSAGE_MAP()
	virtual int ExitInstance();

protected:

	HMENU m_hFieldImageFrmMenu;
	HACCEL m_hFieldImageFrmAccel;	

	HMENU m_hBlobTreeEditorFrmMenu;
	HACCEL m_hBlobTreeEditorFrmAccel;

};

extern CSketchFrameworkApp theApp;