// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2004-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt



// always include a few math headers...
#include <limits.h>
#include <float.h>
#include <cmath>

// define this to get OpenGL support
#define __RMS_DEBUG_WANT_GL


#ifdef _WIN32
// for windows dlls

#ifdef RMSIMPLICIT_DLL_EXPORT
// define symbol RMS_DLL_EXPORT when compiling dll
#define RMSIMPLICIT_ITEM __declspec(dllexport)
#else
// otherwise, automagically define this for dll clients
#define RMSIMPLICIT_ITEM __declspec(dllimport)
#endif

#else
// for a static library or other platforms

#define RMSIMPLICIT_ITEM

#endif



// sometimes we have to make our own pi
#ifndef M_PI
#define M_PI 3.1415926535f
#endif 

// numerical error tolerances
#define RMSUTIL_TOLERANCE 0.000001

/* some handy macros */
#define RMSUTIL_TORADIANS(x) (((float)(x)*M_PI)/180.0f)
#define RMSUTIL_TODEGREES(x) (((float)(x)*180.0f)/M_PI)



#pragma warning( disable : 4100 )

