#ifndef __RMSUI_DYNAMIC_TOOL3D_H__
#define __RMSUI_DYNAMIC_TOOL3D_H__

#include "Tool.h"
#include "Geometry.h"
#include "ConstraintSet.h"

namespace rmsui 
{

class DynamicTool3D : public ITool3D
{
public:
	DynamicTool3D();

	virtual ~DynamicTool3D() {}

	virtual void SetTarget( ITool3DTarget * pTarget );

	virtual void TargetFrameChanged();

	virtual void Render( const ViewState & viewState );

	virtual bool Intersect( const Wml::Ray3f & ray, const ViewState & viewState,
							Wml::Vector3f & ptPosition, float & fDepth );

	virtual Wml::Vector3f Move( SelectedTargetInfo & targetInfo,
								const ViewState & viewState,
								bool bInitialize = false );


	void ClearConstraints(bool bPinned = true);
	ConstraintSet & GetConstraints() { return m_vConstraints; }

	PivotSet & Pivots() { return m_vPivots; }

protected:
	
	ConstraintSet m_vConstraints;
	Constraint * m_pCurConstraint;

	PivotSet m_vPivots;

	void UpdateConstraints();

};


} // namespace rmsui


#endif   // __RMSUI_TOOL3D_TRANSLATION_H__