// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2005-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#ifndef __RMSUI_TOOL3D_ROTATION_H__
#define __RMSUI_TOOL3D_ROTATION_H__

#include "Tool.h"
#include "Geometry.h"

namespace rmsui 
{

class LocalRotationTool3D : public  ITool3D
{
public:
	LocalRotationTool3D( );

	virtual ~LocalRotationTool3D() {}

	virtual void TargetFrameChanged();

	virtual void Render( const ViewState & viewState );

	virtual bool Intersect( const Wml::Ray3f & ray, 
							Wml::Vector3f & ptPosition, float & fDepth );

	virtual Wml::Vector3f Move( SelectedTargetInfo & targetInfo,
								const ViewState & viewState,
								bool bInitialize = false );

protected:

	Wml::Vector3f MoveTumble( SelectedTargetInfo & targetInfo,
							  const ViewState & viewState,
							  bool bInitialize = false );

	Wml::Vector3f MoveAxis2( const Wml::Vector3f & vAxis,
							 const Wml::Ray3f & eyeRay,
							 SelectedTargetInfo & targetInfo,
							 bool bInitialize = false );

	Wml::Vector3f MoveAxis( const Wml::Vector3f & vAxis,
							const Wml::Ray3f & eyeRay,
							SelectedTargetInfo & targetInfo,
							bool bInitialize = false );

	void UpdateCircleTargets();

	Circle m_axisTargets[3];
	Sphere m_tumbleTarget;
	Circle m_tumbleTargetOutline;
	unsigned int m_nSelected;

	Wml::Vector3f m_ptLinePoint;

};


}  // namspace rmsui


#endif // __RMSUI_TOOL3D_ROTATION_H__