// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2004-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#include "StdAfx.h"
#include "WmlColors.h"

using namespace Wml;


unsigned char ColorRGBA::ToByte( float fValue )
{
	int nValue = (int)(fValue * 255.0f);
	if ( nValue > 255 )
		nValue = 255;
	if ( nValue < 0 )
		nValue = 0;
	return (unsigned char)nValue;
}


const ColorRGBA ColorRGBA::BLACK(0.0f,0.0f,0.0f);
const ColorRGBA ColorRGBA::WHITE(1.0f,1.0f,1.0f);

const ColorRGBA ColorRGBA::RED(1.0f,0.0f,0.0f);
const ColorRGBA ColorRGBA::GREEN(0.0f,1.0f,0.0f);
const ColorRGBA ColorRGBA::BLUE(0.0f,0.0f,1.0f);

const ColorRGBA ColorRGBA::YELLOW(1.0f,1.0f,0.0f);
const ColorRGBA ColorRGBA::MAGENTA(1.0f,0.0f,1.0f);


const ColorRGB ColorConstants::BLACK(0.0f,0.0f,0.0f);
const ColorRGB ColorConstants::WHITE(1.0f,1.0f,1.0f);

const ColorRGB ColorConstants::RED(1.0f,0.0f,0.0f);
const ColorRGB ColorConstants::GREEN(0.0f,1.0f,0.0f);
const ColorRGB ColorConstants::BLUE(0.0f,0.0f,1.0f);

const ColorRGB ColorConstants::YELLOW(1.0f,1.0f,0.0f);
const ColorRGB ColorConstants::MAGENTA(1.0f,0.0f,1.0f);