// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2004-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#ifndef WMLEXTINTRPLN3LIN3_H
#define WMLEXTINTRPLN3LIN3_H

#include "WmlExt.h"

#include <WmlPlane3.h>
#include <WmlRay3.h>

namespace Wml
{

// The boolean bUnitNormal is a hint about whether or not the plane normal
// is unit length.  If it is not, the length must be calculated by these
// routines.  For batch calls, the plane normal should be unitized in advance
// to avoid the expensive length calculation.


template <class Real>
bool WMLEXT_ITEM FindIntersection (const Plane3<Real>& rkPlane,
    const Ray3<Real>& rkRay, int& riQuantity, Vector3<Real> akP[2], bool bUnitNormal);

}

#endif		// WMLEXTINTRPLN3LIN3_H