// Ryan Schmidt - rms@unknownroad.com
// Copyright (c) 2004-2010
// Distributed under the Boost Software License, Version 1.0.
// http://www.boost.org/LICENSE_1_0.txt


#ifndef RMS_WMLEXT_SMOOTH_CAMERA_INTERPOLATOR_H
#define RMS_WMLEXT_SMOOTH_CAMERA_INTERPOLATOR_H

#include "WmlExt.h"
#include "ExtendedWmlCamera.h"

#include <WmlQuaternion.h>


namespace Wml {



class WMLEXT_ITEM SmoothCameraInterpolator {
public:

	SmoothCameraInterpolator();
	SmoothCameraInterpolator( ExtendedWmlCamera * pCamera, 
							  const Wml::Vector3f & newLocation, 
							  const Wml::Vector3f & newTarget,
							  unsigned int nInterpSteps);
	~SmoothCameraInterpolator();

	bool RunSlerpStep();

protected:
	Wml::ExtendedWmlCamera * m_pCamera;
	Wml::Vector3f m_vInitialUp;
	Wml::Vector3f m_vInitialLeft;
	Wml::Vector3f m_vInitialDirection;
	Wml::Vector3f m_vInitialTarget;
	float m_fInitialDistance;

	Wml::Vector3f m_vFinalTarget;
	float m_fFinalDistance;


	Wml::Quaternionf m_qStart;
	Wml::Quaternionf m_qEnd;


	Wml::Vector3f m_vPerp;
	float m_fStartAngle;

	unsigned int m_nInterpSteps;
	unsigned int m_nStepsElapsed;

};


} // end namespace Wml


#endif   // RMS_WMLEXT_SMOOTH_CAMERA_INTERPOLATOR_H